Index: src/molecule.hpp
===================================================================
--- src/molecule.hpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/molecule.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -21,12 +21,10 @@
 #include <vector>
 
-#include <boost/iterator/transform_iterator.hpp>
-
 #include <string>
 
+#include "AtomIdSet.hpp"
 #include "Atom/AtomSet.hpp"
 #include "CodePatterns/Cacheable.hpp"
 #include "CodePatterns/Observer/Observable.hpp"
-#include "CodePatterns/Observer/ObservedIterator.hpp"
 #include "Descriptors/AtomIdDescriptor.hpp"
 #include "Fragmentation/HydrogenSaturation_enum.hpp"
@@ -35,8 +33,6 @@
 #include "IdPool_policy.hpp"
 #include "IdPool.hpp"
+#include "Shapes/Shape.hpp"
 #include "types.hpp"
-
-// TODO: Was is the include of MoleculeDescriptor_impl.hpp doing in molecule.hpp
-#include "Descriptors/MoleculeDescriptor_impl.hpp"
 
 /****************************************** forward declarations *****************************/
@@ -54,18 +50,7 @@
 class MoleculeLeafClass;
 class MoleculeListClass;
-class periodentafel;
+class MoleculeUnittest;
 class RealSpaceMatrix;
 class Vector;
-class Shape;
-
-/******************************** Some definitions for easier reading **********************************/
-
-struct FromIdToAtom :
-  public std::unary_function<atom *, atomId_t>
-{
-    atom * operator()(atomId_t id) const {
-     return World::getInstance().getAtom(AtomById(id));
-    }
-};
 
 /************************************* Class definitions ****************************************/
@@ -76,11 +61,15 @@
 class molecule : public Observable
 {
+  //!> grant unit test access
+  friend class MoleculeUnittest;
+  //!> function may access cstor
   friend molecule *NewMolecule();
+  //!> function may access dstor
   friend void DeleteMolecule(molecule *);
 
 public:
-  typedef std::set<atomId_t> atomIdSet;
-  typedef boost::transform_iterator<FromIdToAtom, atomIdSet::iterator, atom *, atomId_t> iterator;
-  typedef boost::transform_iterator<FromIdToAtom, atomIdSet::const_iterator, const atom *, atomId_t const &> const_iterator;
+  typedef AtomIdSet::atomIdSet atomIdSet;
+  typedef AtomIdSet::iterator iterator;
+  typedef AtomIdSet::const_iterator const_iterator;
 
   int MDSteps; //!< The number of MD steps in Trajectories
@@ -97,5 +86,5 @@
   Cacheable<int> BondCount; //!< number of atoms, brought up-to-date by doCountBonds()
   moleculeId_t id;
-  atomIdSet atomIds; //<!set of atomic ids to check uniqueness of atoms
+  AtomIdSet atomIds; //<!set of atomic ids to check uniqueness of atoms
   IdPool<atomId_t, uniqueId> atomIdPool;  //!< pool of internal ids such that way may guarantee uniqueness
 
@@ -125,12 +114,43 @@
   World::AtomComposite getAtomSet() const;
 
-  iterator begin();
-  const_iterator begin() const;
-  iterator end();
-  const_iterator end() const;
-  bool empty() const;
-  size_t size() const;
-  const_iterator find(atom * key) const;
-  pair<iterator, bool> insert(atom * const key);
+  // simply pass on all functions to AtomIdSet
+  iterator begin() {
+    return atomIds.begin();
+  }
+  const_iterator begin() const
+  {
+    return atomIds.begin();
+  }
+  iterator end()
+  {
+    return atomIds.end();
+  }
+  const_iterator end() const
+  {
+    return atomIds.end();
+  }
+  bool empty() const
+  {
+    return atomIds.empty();
+  }
+  size_t size() const
+  {
+    return atomIds.size();
+  }
+  const_iterator find(atom * key) const
+  {
+    return atomIds.find(key);
+  }
+
+  /** Returns the set of atomic ids contained in this molecule.
+   *
+   * @return set of atomic ids
+   */
+  const atomIdSet & getAtomIds() const {
+    return atomIds.getAtomIds();
+  }
+
+  std::pair<iterator, bool> insert(atom * const key);
+
   bool containsAtom(atom* key);
 
@@ -145,4 +165,5 @@
    */
   const_iterator erase(const_iterator loc);
+
   /** Erase an atom from the list.
    * \note This should only be called by atom::removeFromMolecule(),
@@ -177,4 +198,9 @@
 
 public:
+
+  /** Function to create a bounding spherical shape for the currently associated atoms.
+   *
+   */
+  Shape getBoundingShape() const;
 
   /// remove atoms from molecule.
@@ -229,5 +255,5 @@
   bond * CopyBond(atom *left, atom *right, bond *CopyBond);
 
-  molecule *CopyMolecule() const;
+  molecule *CopyMolecule(const Vector &offset = zeroVec) const;
   molecule* CopyMoleculeFromSubRegion(const Shape&) const;
 
Index: src/unittests/AtomIdSetUnitTest.cpp
===================================================================
--- src/unittests/AtomIdSetUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/unittests/AtomIdSetUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,148 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * AtomIdSetUnitTest.cpp
+ *
+ *  Created on: Feb 21, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include <algorithm>
+
+#include "Atom/atom.hpp"
+#include "AtomIdSet.hpp"
+#include "CodePatterns/Assert.hpp"
+#include "World.hpp"
+
+#include "AtomIdSetUnitTest.hpp"
+
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( AtomIdSetUnittest );
+
+size_t AtomIdSetUnittest::MaxAtoms = 6;
+
+void AtomIdSetUnittest::setUp(){
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+
+  atomVector.resize((size_t)MaxAtoms);
+  std::generate_n(atomVector.begin(), MaxAtoms,
+      boost::bind(&World::createAtom, boost::ref(World::getInstance())));
+}
+
+void AtomIdSetUnittest::tearDown()
+{
+  World::purgeInstance();
+}
+
+void AtomIdSetUnittest::inserteraseTest()
+{
+  // insert all
+  for (size_t i=0; i< MaxAtoms; ++i) {
+    atoms.insert(atomVector[i]);
+  }
+  CPPUNIT_ASSERT_EQUAL( (size_t)MaxAtoms, atoms.size() );
+
+  // erase them again
+  for (size_t i=0; i< MaxAtoms; ++i) {
+    atoms.erase(atomVector[i]);
+  }
+  CPPUNIT_ASSERT_EQUAL( (size_t)0, atoms.size() );
+
+  {
+    // use atomVector in cstor
+    AtomIdSet otherAtoms(atomVector);
+    CPPUNIT_ASSERT_EQUAL( (size_t)MaxAtoms, otherAtoms.size() );
+  }
+}
+
+void AtomIdSetUnittest::positionTest()
+{
+  // non-const iterators
+  CPPUNIT_ASSERT( atoms.begin() == atoms.end() );
+
+  // const iterators
+  {
+    AtomIdSet::const_iterator beg_iter = atoms.begin();
+    AtomIdSet::const_iterator end_iter = atoms.end();
+    CPPUNIT_ASSERT( beg_iter == end_iter );
+  }
+
+  // insert an element
+  atoms.insert(atomVector[0]);
+  CPPUNIT_ASSERT( atoms.begin() != atoms.end() );
+
+  {
+    AtomIdSet::const_iterator beg_iter = atoms.begin();
+    AtomIdSet::const_iterator end_iter = atoms.end();
+    CPPUNIT_ASSERT( beg_iter != end_iter );
+    ++beg_iter;
+    CPPUNIT_ASSERT( beg_iter == end_iter );
+  }
+}
+
+void AtomIdSetUnittest::findTest()
+{
+  // search for atom
+  atoms.insert(atomVector[0]);
+  CPPUNIT_ASSERT( atoms.find(atomVector[0]) == atoms.begin() );
+  CPPUNIT_ASSERT( atoms.find(atomVector[0]) != atoms.end() );
+  atoms.erase(atomVector[0]);
+
+  // search for key
+  atoms.insert(atomVector[0]->getId());
+  CPPUNIT_ASSERT( atoms.find(atomVector[0]->getId()) == atoms.begin() );
+  CPPUNIT_ASSERT( atoms.find(atomVector[0]->getId()) != atoms.end() );
+  atoms.erase(atomVector[0]->getId());
+}
+
+
+void AtomIdSetUnittest::emptyTest()
+{
+  // initially empty
+  CPPUNIT_ASSERT( atoms.empty() );
+
+  // filled with one then no more
+  atoms.insert(atomVector[0]);
+  CPPUNIT_ASSERT( !atoms.empty() );
+
+  // erase and again empty
+  atoms.erase(atomVector[0]);
+  CPPUNIT_ASSERT( atoms.empty() );
+}
+
+void AtomIdSetUnittest::sizeTest()
+{
+  // initially empty
+  CPPUNIT_ASSERT_EQUAL( (size_t)0, atoms.size() );
+
+  // filled with one, then no more
+  atoms.insert(atomVector[0]);
+  CPPUNIT_ASSERT_EQUAL( (size_t)1, atoms.size() );
+
+  // erase and again empty
+  atoms.erase(atomVector[0]);
+  CPPUNIT_ASSERT_EQUAL( (size_t)0, atoms.size() );
+}
+
Index: src/unittests/AtomIdSetUnitTest.hpp
===================================================================
--- src/unittests/AtomIdSetUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/unittests/AtomIdSetUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,52 @@
+/*
+ * AtomIdSetUnitTest.hpp
+ *
+ *  Created on: Feb 21, 2012
+ *      Author: heber
+ */
+
+#ifndef ATOMIDSETUNITTEST_HPP_
+#define ATOMIDSETUNITTEST_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <cppunit/extensions/HelperMacros.h>
+
+#include <vector>
+
+class atom;
+
+#include "AtomIdSet.hpp"
+
+class AtomIdSetUnittest : public CppUnit::TestFixture
+{
+  CPPUNIT_TEST_SUITE( AtomIdSetUnittest );
+  CPPUNIT_TEST ( inserteraseTest );
+  CPPUNIT_TEST ( positionTest );
+  CPPUNIT_TEST ( findTest );
+  CPPUNIT_TEST ( emptyTest );
+  CPPUNIT_TEST ( sizeTest );
+  CPPUNIT_TEST_SUITE_END();
+
+public:
+  void setUp();
+  void tearDown();
+
+  void inserteraseTest();
+  void positionTest();
+  void findTest();
+  void emptyTest();
+  void sizeTest();
+
+private:
+  std::vector<atom *> atomVector;
+  AtomIdSet atoms;
+
+  static size_t MaxAtoms;
+};
+
+#endif /* ATOMIDSETUNITTEST_HPP_ */
Index: src/unittests/Makefile.am
===================================================================
--- src/unittests/Makefile.am	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/unittests/Makefile.am	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -12,4 +12,5 @@
 include ../../src/Descriptors/unittests/Makefile.am
 include ../../src/Element/unittests/Makefile.am
+include ../../src/Filling/unittests/Makefile.am
 include ../../src/Fragmentation/unittests/Makefile.am
 include ../../src/Graph/unittests/Makefile.am
@@ -28,8 +29,10 @@
 
 GENERALTESTS = \
+  AtomIdSetUnitTest \
   BoxUnitTest \
   Box_BoundaryConditionsTest \
   FormulaUnittest \
   ListOfBondsUnitTest \
+  MoleculeUnitTest \
   WorldTimeUnitTest
 
@@ -59,4 +62,5 @@
 
 ALLLIBS = \
+	../libMolecuilderFilling.la \
 	../libMolecuilderUI.la \
 	../libMolecuilder.la \
@@ -70,4 +74,5 @@
 	${DESCRIPTORTESTSSOURCES} \
 	${ELEMENTTESTSSOURCES} \
+	${FILLINGTESTSSOURCES} \
 	${FRAGMENTATIONTESTSSOURCES} \
 	${GRAPHTESTSSOURCES} \
@@ -81,8 +86,10 @@
 	${UIELEMENTSMENUTESTSSOURCES} \
 	stubs/ObserverStub.cpp \
+	AtomIdSetUnitTest.cpp \
   BoxUnitTest.cpp \
 	Box_BoundaryConditionsUnitTest.cpp \
   FormulaUnitTest.cpp \
   ListOfBondsUnitTest.cpp \
+  MoleculeUnitTest.cpp \
   WorldTimeUnitTest.cpp
 
@@ -92,4 +99,5 @@
 	${DESCRIPTORTESTSHEADERS} \
 	${ELEMENTTESTSHEADERS} \
+	${FILLINGTESTSHEADERS} \
 	${FRAGMENTATIONTESTSHEADERS} \
 	${GRAPHTESTSHEADERS} \
@@ -103,8 +111,10 @@
 	${UIELEMENTSMENUTESTSHEADERS} \
 	stubs/ObserverStub.hpp \
+	AtomIdSetUnitTest.hpp \
   BoxUnitTest.hpp \
 	Box_BoundaryConditionsUnitTest.hpp \
   FormulaUnitTest.hpp \
   ListOfBondsUnitTest.hpp \
+  MoleculeUnitTest.hpp \
   WorldTimeUnitTest.hpp
   
@@ -114,5 +124,7 @@
 	BoxUnitTest.hpp \
 	stubs/ObserverStub.cpp \
-	stubs/ObserverStub.hpp	
+	stubs/ObserverStub.hpp \
+	../Shapes/unittests/stubs/ApproximateShapeAreaStub.cpp \
+	../Shapes/unittests/stubs/ApproximateShapeVolumeStub.cpp
 BoxUnitTest_LDADD = \
 	../libMolecuilder.la \
@@ -120,4 +132,9 @@
 	../libMolecuilderHelpers.la \
 	$(top_builddir)/LinearAlgebra/src/LinearAlgebra/libLinearAlgebra.la
+
+AtomIdSetUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	AtomIdSetUnitTest.cpp \
+	AtomIdSetUnitTest.hpp
+AtomIdSetUnitTest_LDADD =  $(ALLLIBS)
 
 Box_BoundaryConditionsTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
@@ -140,4 +157,12 @@
 ListOfBondsUnitTest_LDADD = $(ALLLIBS)
 
+MoleculeUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	MoleculeUnitTest.cpp \
+	MoleculeUnitTest.hpp
+MoleculeUnitTest_LDADD = \
+	../libMolecuilderUI.la \
+	../libMolecuilder.la \
+	$(top_builddir)/LinearAlgebra/src/LinearAlgebra/libLinearAlgebra.la
+
 WorldTimeUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
 	WorldTimeUnitTest.cpp \
Index: src/unittests/MoleculeUnitTest.cpp
===================================================================
--- src/unittests/MoleculeUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/unittests/MoleculeUnitTest.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,116 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * MoleculeUnitTest.cpp
+ *
+ *  Created on: Mar 19, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include <algorithm>
+
+#include "Atom/atom.hpp"
+#include "CodePatterns/Assert.hpp"
+#include "Element/element.hpp"
+#include "Element/periodentafel.hpp"
+#include "molecule.hpp"
+
+#include "MoleculeUnitTest.hpp"
+
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( MoleculeUnittest );
+
+size_t MoleculeUnittest::MaxAtoms = 6;
+
+void MoleculeUnittest::setUp(){
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+
+  atomVector.resize((size_t)MaxAtoms);
+  std::generate_n(atomVector.begin(), MaxAtoms,
+      boost::bind(&World::createAtom, boost::ref(World::getInstance())));
+  std::for_each(atomVector.begin(), atomVector.end(),
+      boost::bind(static_cast<void (AtomInfo::*)(int)>(&AtomInfo::setType), _1, (atomicNumber_t)1));
+
+  mol = new molecule;
+  std::for_each(atomVector.begin(), atomVector.end(),
+      boost::bind(&molecule::AddAtom, boost::ref(mol), _1));
+}
+
+void MoleculeUnittest::tearDown()
+{
+  delete mol;
+  World::purgeInstance();
+}
+
+/** Unit test for molecule::getBoundingShape() with a linear chain
+ *
+ */
+void MoleculeUnittest::getBoundingShapeTest_linearchain()
+{
+  // prepare a chain of atoms
+  double offset = 0.;
+  BOOST_FOREACH(atom *_atom, atomVector) {
+    _atom->setPosition( Vector(offset, 0., 0.) );
+    offset += 1.;
+  }
+
+  {
+    // get bounding shape
+    Shape s = mol->getBoundingShape();
+
+    // check that each atom is truely inside the shape
+    BOOST_FOREACH(atom *_atom, atomVector) {
+      CPPUNIT_ASSERT( s.isInside(_atom->getPosition()) );
+    }
+  }
+}
+
+/** Unit test for molecule::getBoundingShape() with a v-shaped molecule.
+ *
+ */
+void MoleculeUnittest::getBoundingShapeTest_vshaped()
+{
+  double xoffset = -2.5;
+  double yoffset = -2.5;
+  double yadder = -1;
+  BOOST_FOREACH(atom *_atom, atomVector) {
+    _atom->setPosition( Vector(xoffset, yoffset, 0.) );
+    xoffset += 1.;
+    yoffset -= yadder;
+    if (yoffset <= 0) {
+      yadder = 1.;
+    }
+  }
+
+  {
+    // get bounding shape
+    Shape s = mol->getBoundingShape();
+
+    // check that each atom is truely inside the shape
+    BOOST_FOREACH(atom *_atom, atomVector) {
+      CPPUNIT_ASSERT( s.isInside(_atom->getPosition()) );
+    }
+  }
+}
Index: src/unittests/MoleculeUnitTest.hpp
===================================================================
--- src/unittests/MoleculeUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/unittests/MoleculeUnitTest.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,45 @@
+/*
+ * MoleculeUnitTest.hpp
+ *
+ *  Created on: Mar 19, 2012
+ *      Author: heber
+ */
+
+#ifndef MOLECULEUNITTEST_HPP_
+#define MOLECULEUNITTEST_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <cppunit/extensions/HelperMacros.h>
+
+#include <vector>
+
+class atom;
+class molecule;
+
+class MoleculeUnittest : public CppUnit::TestFixture
+{
+  CPPUNIT_TEST_SUITE( MoleculeUnittest );
+  CPPUNIT_TEST ( getBoundingShapeTest_linearchain );
+  CPPUNIT_TEST ( getBoundingShapeTest_vshaped );
+  CPPUNIT_TEST_SUITE_END();
+
+public:
+  void setUp();
+  void tearDown();
+
+  void getBoundingShapeTest_linearchain();
+  void getBoundingShapeTest_vshaped();
+
+private:
+  std::vector<atom *> atomVector;
+  molecule *mol;
+
+  static size_t MaxAtoms;
+};
+
+#endif /* MOLECULEUNITTEST_HPP_ */
Index: src/unittests/stubs/AtomStub.cpp
===================================================================
--- src/unittests/stubs/AtomStub.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/unittests/stubs/AtomStub.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,26 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * AtomStub.cpp
+ *
+ *  Created on: Dec 22, 2011
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Atom/atom.hpp"
+
+int atom::getNr() const {
+  return 0;
+}
Index: src/unittests/stubs/WorldStub.cpp
===================================================================
--- src/unittests/stubs/WorldStub.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/unittests/stubs/WorldStub.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,76 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * WorldStub.cpp
+ *
+ *  Created on: Dec 22, 2011
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "World.hpp"
+
+#include "CodePatterns/Observer/Channels.hpp"
+#include "CodePatterns/Observer/Notification.hpp"
+#include "CodePatterns/Observer/ObservedContainer_impl.hpp"
+#include "CodePatterns/Singleton_impl.hpp"
+#include "Descriptors/AtomDescriptor.hpp"
+#include "Descriptors/AtomIdDescriptor_impl.hpp"
+
+#include "IdPool_impl.hpp"
+
+atom* World::_lastchangedatom = NULL;
+
+AtomDescriptor::AtomDescriptor(impl_ptr ptr)
+{}
+
+AtomDescriptor::~AtomDescriptor()
+{}
+
+atom * AtomById(unsigned int i)
+{
+  return NULL;
+}
+
+World::World() :
+    Observable("World"),
+    atoms(this),
+    selectedAtoms(this),
+    atomIdPool(0, 20, 100),
+    molecules(this),
+    selectedMolecules(this),
+    moleculeIdPool(0, 20,100)
+{
+  // observable stuff
+  Channels *OurChannel = new Channels;
+  NotificationChannels.insert( std::make_pair(this, OurChannel) );
+  // add instance for each notification type
+  OurChannel->addChannel(World::AtomInserted);
+  OurChannel->addChannel(World::AtomRemoved);
+}
+
+World::~World()
+{
+  // observable stuff
+  std::map<Observable *, Channels*>::iterator iter = NotificationChannels.find(this);
+  delete iter->second;
+  NotificationChannels.erase(iter);
+}
+
+atom* World::getAtom(AtomDescriptor descr)
+{
+  return NULL;
+}
+
+CONSTRUCT_SINGLETON(World);
